"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.priorityTasks = exports.priorityWf = exports.priority = void 0;
/* eslint-disable no-console */
const v1_1 = require("../..");
const hatchet_client_1 = require("../hatchet-client");
// ❓ Simple Task Priority
exports.priority = hatchet_client_1.hatchet.task({
    name: 'priority',
    defaultPriority: v1_1.Priority.MEDIUM,
    fn: (_, ctx) => __awaiter(void 0, void 0, void 0, function* () {
        return {
            priority: ctx.priority(),
        };
    }),
});
// !!
// ❓ Task Priority in a Workflow
exports.priorityWf = hatchet_client_1.hatchet.workflow({
    name: 'priorityWf',
    defaultPriority: v1_1.Priority.LOW,
});
// !!
exports.priorityWf.task({
    name: 'child-medium',
    fn: (_, ctx) => __awaiter(void 0, void 0, void 0, function* () {
        return {
            priority: ctx.priority(),
        };
    }),
});
exports.priorityWf.task({
    name: 'child-high',
    // will inherit the default priority from the workflow
    fn: (_, ctx) => __awaiter(void 0, void 0, void 0, function* () {
        return {
            priority: ctx.priority(),
        };
    }),
});
exports.priorityTasks = [exports.priority, exports.priorityWf];
